export declare type Version = string;
export interface EncodingSpec {
    [key: number]: number;
}
export declare type EncodedEntity = Primitive | string | DataObject | EncodedEntity[];
export interface DataObject {
    [key: string]: EncodedEntity;
    [key: number]: EncodedEntity;
}
export interface Metadata {
    [key: number]: EncodedEntity;
}
export declare type EncodingKeys = string[];
export declare type Header = [Version, EncodingKeys, EncodingSpec, Metadata];
export declare type Reference = string;
export declare type Entity = string | object | any[] | symbol | Function;
export declare type Primitive = boolean | number | null;
export declare type EncodedScalar = string;
export declare type ScalarValue = Primitive | Reference | EncodedScalar;
export declare type PreszrFormat = [Header, ...EncodedEntity[]];
export declare type PreszrOutput = PreszrFormat | Primitive | EncodedScalar;
export declare const undefinedEncoding = "-";
export declare const infinityEncoding = "Infinity";
export declare const negInfinityEncoding = "-Infinity";
export declare const negZeroEncoding = "-0";
export declare const nanEncoding = "NaN";
export declare const noResultPlaceholder = "";
export declare function tryEncodeScalar(num: any): EncodedScalar | Primitive;
export declare function tryDecodeScalar(candidate: any): any;
export declare const unrecognizedSymbolKey: string;
//# sourceMappingURL=data.d.ts.map