"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecodeContext = void 0;
const data_1 = require("../data");
const errors_1 = require("../errors");
var DecodeStage;
(function (DecodeStage) {
    DecodeStage[DecodeStage["Create"] = 0] = "Create";
    DecodeStage[DecodeStage["Init"] = 1] = "Init";
})(DecodeStage || (DecodeStage = {}));
class DecodeContext {
    constructor(_target) {
        this._target = _target;
        this._stage = DecodeStage.Create;
    }
    next() {
        this._stage = DecodeStage.Init;
    }
    decode(value) {
        if (this._stage === DecodeStage.Create) {
            throw new errors_1.PreszrError("Decoding", `Illegal call to 'decode' in the Create stage. You can only do that during the Init stage.`);
        }
        const decodedPrimitive = (0, data_1.tryDecodeScalar)(value);
        if (decodedPrimitive !== data_1.noResultPlaceholder) {
            return decodedPrimitive;
        }
        value = value;
        return this._target[value];
    }
}
exports.DecodeContext = DecodeContext;
//# sourceMappingURL=decode-context.js.map