"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setEncoding = exports.mapEncoding = void 0;
const interface_1 = require("../interface");
const utils_1 = require("../utils");
const fixed_1 = require("./fixed");
exports.mapEncoding = {
    name: (0, utils_1.getBuiltInEncodingName)("Map"),
    version: 0,
    [interface_1.fixedIndexProp]: fixed_1.Fixed.Map,
    protos: [Map.prototype],
    encode(input, ctx) {
        const array = [];
        for (const key of input.keys()) {
            const value = input.get(key);
            array.push([ctx.encode(key), ctx.encode(value)]);
        }
        return array;
    },
    decoder: {
        create(encodedValue, ctx) {
            return new Map();
        },
        init(target, encoded, ctx) {
            for (const [key, value] of encoded) {
                target.set(ctx.decode(key), ctx.decode(value));
            }
        }
    }
};
exports.setEncoding = {
    name: (0, utils_1.getBuiltInEncodingName)("Set"),
    version: 0,
    [interface_1.fixedIndexProp]: fixed_1.Fixed.Set,
    protos: [Set.prototype],
    encode(input, ctx) {
        const outArray = [];
        for (const item of input) {
            outArray.push(ctx.encode(item));
        }
        return outArray;
    },
    decoder: {
        create() {
            return new Set();
        },
        init(target, encoded, ctx) {
            for (const item of encoded) {
                target.add(ctx.decode(item));
            }
        }
    }
};
//# sourceMappingURL=collections.js.map