"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Fixed = void 0;
// Fixed indexes for built-in encodings. This makes payloads smaller
// and access a tiny bit faster for them.
var Fixed;
(function (Fixed) {
    /*** UNSUPPORTED BLOCK */
    Fixed[Fixed["Unsupported"] = 1] = "Unsupported";
    // OBJECT BLOCK
    Fixed[Fixed["Object"] = 10] = "Object";
    Fixed[Fixed["Array"] = 11] = "Array";
    Fixed[Fixed["NullProto"] = 12] = "NullProto";
    Fixed[Fixed["Map"] = 13] = "Map";
    Fixed[Fixed["Set"] = 14] = "Set";
    // SCALAR BLOCK
    Fixed[Fixed["RegExp"] = 30] = "RegExp";
    Fixed[Fixed["Date"] = 31] = "Date";
    Fixed[Fixed["FundBool"] = 32] = "FundBool";
    Fixed[Fixed["FundString"] = 33] = "FundString";
    Fixed[Fixed["FundNumber"] = 34] = "FundNumber";
    // BINARY BLOCK
    Fixed[Fixed["ArrayBuffer"] = 50] = "ArrayBuffer";
    Fixed[Fixed["SharedArrayBuffer"] = 51] = "SharedArrayBuffer";
    Fixed[Fixed["Uint8Array"] = 52] = "Uint8Array";
    Fixed[Fixed["Uint8ClampedArray"] = 53] = "Uint8ClampedArray";
    Fixed[Fixed["Uint16Array"] = 54] = "Uint16Array";
    Fixed[Fixed["Uint32Array"] = 55] = "Uint32Array";
    Fixed[Fixed["Int8Array"] = 56] = "Int8Array";
    Fixed[Fixed["Int16Array"] = 57] = "Int16Array";
    Fixed[Fixed["Int32Array"] = 58] = "Int32Array";
    Fixed[Fixed["Float32Array"] = 59] = "Float32Array";
    Fixed[Fixed["Float64Array"] = 60] = "Float64Array";
    Fixed[Fixed["DataView"] = 61] = "DataView";
    Fixed[Fixed["BigUint64Array"] = 62] = "BigUint64Array";
    Fixed[Fixed["BigInt64Array"] = 63] = "BigInt64Array";
    // ERROR BLOCK
    Fixed[Fixed["EvalError"] = 80] = "EvalError";
    Fixed[Fixed["RangeError"] = 81] = "RangeError";
    Fixed[Fixed["ReferenceError"] = 82] = "ReferenceError";
    Fixed[Fixed["TypeError"] = 83] = "TypeError";
    Fixed[Fixed["URIError"] = 84] = "URIError";
    Fixed[Fixed["SyntaxError"] = 85] = "SyntaxError";
    Fixed[Fixed["Error"] = 86] = "Error";
    Fixed[Fixed["UnrecognizedSymbol"] = 99] = "UnrecognizedSymbol";
    // ... FREE BLOCK 76-99
    Fixed[Fixed["End"] = 100] = "End";
    // Block end marker 100
    // Custom encodings start at index 100.
})(Fixed = exports.Fixed || (exports.Fixed = {}));
//# sourceMappingURL=fixed.js.map