"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBuiltInEncoding = exports.builtinEncodings = exports.objectEncoding = exports.nullPlaceholder = exports.getUnsupportedEncoding = exports.arrayEncoding = void 0;
const objects_1 = require("./objects");
Object.defineProperty(exports, "arrayEncoding", { enumerable: true, get: function () { return objects_1.arrayEncoding; } });
Object.defineProperty(exports, "getUnsupportedEncoding", { enumerable: true, get: function () { return objects_1.getUnsupportedEncoding; } });
Object.defineProperty(exports, "nullPlaceholder", { enumerable: true, get: function () { return objects_1.nullPlaceholder; } });
Object.defineProperty(exports, "objectEncoding", { enumerable: true, get: function () { return objects_1.objectEncoding; } });
const scalar_1 = require("./scalar");
const binary_1 = require("./binary");
const collections_1 = require("./collections");
const errors_1 = require("./errors");
const utils_1 = require("../utils");
exports.builtinEncodings = [
    objects_1.objectEncoding,
    objects_1.arrayEncoding,
    objects_1.nullPrototypeEncoding,
    ...scalar_1.wrapperEncodings,
    scalar_1.dateEncoding,
    scalar_1.regexpEncoding,
    ...binary_1.typedArrayEncodings,
    binary_1.arrayBufferEncoding,
    collections_1.mapEncoding,
    collections_1.setEncoding,
    ...errors_1.errorEncodings,
    binary_1.sharedArrayBufferEncoding
];
const builtInEncodingByProto = new Map((0, utils_1.flatten)(exports.builtinEncodings.map(encoding => encoding.protos.map(proto => [proto, encoding]))));
function getBuiltInEncoding(obj) {
    if (obj == null) {
        return builtInEncodingByProto.get(objects_1.nullPlaceholder);
    }
    return builtInEncodingByProto.get(obj);
}
exports.getBuiltInEncoding = getBuiltInEncoding;
//# sourceMappingURL=index.js.map