import { Encoding, EncodingSpecifier, PrototypeEncoding, PrototypeEncodingSpecifier, SymbolEncoding, UserEncoding } from "../interface";
export declare function makeSymbolEncoding(x: SymbolEncoding | symbol): SymbolEncoding;
export declare function makeProtoEncodingByCtor(ctor: Function): PrototypeEncoding;
export declare function makeProtoEncoding(specifier: PrototypeEncodingSpecifier): PrototypeEncoding;
export declare function makeFullEncoding(specifier: EncodingSpecifier): UserEncoding;
export declare function getEncodingKey(enc: Encoding): string;
export interface ProtoEncodingKeyInfo {
    type: "prototype";
    name: string;
    version: number;
}
export interface SymbolEncodingKeyInfo {
    type: "symbol";
    name: string;
}
export declare type EncodingKeyInfo = ProtoEncodingKeyInfo | SymbolEncodingKeyInfo;
export declare function mustParseEncodingKey(key: string): EncodingKeyInfo;
//# sourceMappingURL=utils.d.ts.map