import { Preszr as PreszrClass } from "./core";
import { PreszrOutput } from "./data";
import { DeepPartial, EncodingSpecifier, PreszrConfig } from "./interface";
export { Encoding, EncodingSpecifier, PrototypeEncoding, PrototypeEncodingSpecifier, Decoder, SymbolEncoding, CreateContext, InitContext, DeepPartial, PreszrConfig, EncodeContext } from "./interface";
/**
 * Encodes a value using preszr with the default settings.
 * @param value A value to encode.
 */
export declare const encode: (value: unknown) => PreszrOutput;
/**
 * Decodes a value using preszr with the default settings.
 * @param encoded The default
 */
export declare const decode: <T = unknown>(encoded: PreszrOutput) => T;
/**
 * Creates a new `Preszr` instance. Can be called with or without `new`.
 * @param config The configuration. Should be the same in the source and destination.
 * @constructor
 */
export declare const Preszr: {
    (config?: DeepPartial<PreszrConfig> | undefined): Preszr;
    (specs: EncodingSpecifier[]): Preszr;
    new (specs: EncodingSpecifier[]): Preszr;
    new (config?: DeepPartial<PreszrConfig> | undefined): Preszr;
};
/**
 * A configured Preszr instance used for encoding and decoding.
 */
export declare type Preszr = PreszrClass;
//# sourceMappingURL=index.d.ts.map