"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Preszr = exports.decode = exports.encode = void 0;
const core_1 = require("./core");
const default_1 = require("./default");
/**
 * Encodes a value using preszr with the default settings.
 * @param value A value to encode.
 */
const encode = (value) => default_1.defaultPreszr.encode(value);
exports.encode = encode;
/**
 * Decodes a value using preszr with the default settings.
 * @param encoded The default
 */
const decode = (encoded) => default_1.defaultPreszr.decode(encoded);
exports.decode = decode;
/**
 * Creates a new `Preszr` instance. Can be called with or without `new`.
 * @param config The configuration. Should be the same in the source and destination.
 * @constructor
 */
exports.Preszr = function Preszr(arg) {
    if (Array.isArray(arg)) {
        return new core_1.Preszr({
            encodes: arg
        });
    }
    return new core_1.Preszr(arg);
};
exports.Preszr.prototype = core_1.Preszr.prototype;
//# sourceMappingURL=index.js.map