"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const ava_1 = __importDefault(require("ava"));
const tools_1 = require("../tools");
const default_1 = require("@lib/default");
const fixed_1 = require("@lib/encodings/fixed");
const singleton = (0, tools_1.testBuilder)(default_1.defaultPreszr)
    .title(({ original, title }) => title ?? `array with ${(0, utils_1.stringify)(original[0])} element`)
    .getSimple();
{
    (0, ava_1.default)(singleton, [1], (0, tools_1.preszr)((0, tools_1.items)([1])));
    (0, ava_1.default)(singleton, [true], (0, tools_1.preszr)((0, tools_1.items)([true])));
    (0, ava_1.default)(singleton, [null], (0, tools_1.preszr)((0, tools_1.items)([null])));
    (0, ava_1.default)(singleton, [Infinity], (0, tools_1.preszr)((0, tools_1.items)(["Infinity"])));
    (0, ava_1.default)(singleton, [-Infinity], (0, tools_1.preszr)((0, tools_1.items)(["-Infinity"])));
    (0, ava_1.default)(singleton, [-0], (0, tools_1.preszr)((0, tools_1.items)(["-0"])));
    (0, ava_1.default)(singleton, [NaN], (0, tools_1.preszr)((0, tools_1.items)(["NaN"])));
    (0, ava_1.default)(singleton, [4n], (0, tools_1.preszr)((0, tools_1.items)(["B4"])));
    (0, ava_1.default)(singleton, ["string"], (0, tools_1.preszr)((0, tools_1.items)(["2"], "string")));
    (0, ava_1.default)("Array [{}]", singleton, [{}], (0, tools_1.preszr)((0, tools_1.items)(["2"], {})));
    (0, ava_1.default)("Array [[]]", singleton, [[]], (0, tools_1.preszr)((0, tools_1.items)(["2"], [])));
}
(0, ava_1.default)("deepEqual assertions work for sparse arrays", t => {
    const sparse1 = (0, utils_1.createSparseArray)({ 5: 1, 6: 1 });
    sparse1[5] = 1;
    sparse1[6] = 1;
    t.notDeepEqual(sparse1, [5, 6]);
    t.notDeepEqual(sparse1, (0, utils_1.createSparseArray)({ 1: 1, 2: 1 }));
    t.deepEqual(sparse1, (0, utils_1.createSparseArray)({ 5: 1, 6: 1 }));
});
{
    (0, ava_1.default)("sparse array", singleton, (0, utils_1.createSparseArray)({ 1: 5, 2: 6 }), (0, tools_1.preszr)((0, tools_1.encoded)({ 1: 5, 2: 6 }, fixed_1.Fixed.Array)));
    (0, ava_1.default)("sparse array with reference", singleton, (0, utils_1.createSparseArray)({ 1: {}, 2: {} }), (0, tools_1.preszr)((0, tools_1.encoded)({ 1: "2", 2: "3" }, fixed_1.Fixed.Array), (0, tools_1.items)({}, {})));
    (0, ava_1.default)("array with string keys", singleton, (0, utils_1.createSparseArray)({ 1: 1, a: 2 }), (0, tools_1.preszr)((0, tools_1.encoded)({ 1: 1, a: 2 }, fixed_1.Fixed.Array)));
}
//# sourceMappingURL=array.js.map