"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = __importDefault(require("ava"));
const utils_1 = require("@lib/utils");
const tools_1 = require("../tools");
const default_1 = require("@lib/default");
const utils_2 = require("../utils");
const fixed_1 = require("@lib/encodings/fixed");
const binaryOutputDeepEqual = (0, tools_1.testBuilder)(default_1.defaultPreszr)
    .title(({ original }) => `Binary Type ${(0, utils_1.getClassName)(original)}`)
    .getSimple();
(0, ava_1.default)("deepEqual works on binary types", t => {
    const array = (0, utils_2.createArrayBuffer)(1, 2, 3, 4);
    const array2 = (0, utils_2.createArrayBuffer)(1, 2, 3, 4);
    t.deepEqual(array, array2);
    const array3 = (0, utils_2.createArrayBuffer)(2, 3, 4, 5);
    t.notDeepEqual(array, array3);
    const typed8 = new Uint8Array(array);
    t.notDeepEqual(typed8, array);
    const typed8b = new Uint8Array(array2);
    t.deepEqual(typed8, typed8b);
    const typed16 = new Uint16Array(array);
    t.notDeepEqual(typed16, typed8);
});
const arrayBuffer = (0, utils_2.createArrayBuffer)(1, 2, 3, 4, 5, 6, 7, 8);
const base64 = "AQIDBAUGBwg=";
(0, ava_1.default)(binaryOutputDeepEqual, arrayBuffer, (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.ArrayBuffer)));
(0, ava_1.default)(binaryOutputDeepEqual, (0, utils_2.createSharedArrayBuffer)(1, 2, 3, 4, 5, 6, 7, 8), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.SharedArrayBuffer)));
(0, ava_1.default)(binaryOutputDeepEqual, new Uint8Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.Uint8Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new Uint16Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.Uint16Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new Uint32Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.Uint32Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new Uint8ClampedArray(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.Uint8ClampedArray)));
(0, ava_1.default)(binaryOutputDeepEqual, new BigUint64Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.BigUint64Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new Int8Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.Int8Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new Int16Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.Int16Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new Int32Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.Int32Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new BigInt64Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.BigInt64Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new Float32Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.Float32Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new Float64Array(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.Float64Array)));
(0, ava_1.default)(binaryOutputDeepEqual, new DataView(arrayBuffer), (0, tools_1.preszr)((0, tools_1.encoded)(base64, fixed_1.Fixed.DataView)));
//# sourceMappingURL=binary.js.map