"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = __importDefault(require("ava"));
const _lib_1 = require("@lib");
const tools_1 = require("../tools");
const default_1 = require("@lib/default");
const complexReferences = (0, tools_1.testBuilder)(default_1.defaultPreszr).getSimple();
{
    const o = {};
    const siblingExample = {
        a: o,
        b: o
    };
    (0, ava_1.default)("sibling refs - structural", complexReferences, siblingExample, (0, tools_1.preszr)((0, tools_1.items)({ a: "2", b: "2" }), (0, tools_1.items)({})));
    (0, ava_1.default)("sibling references - identity", t => {
        const result = (0, _lib_1.decode)((0, _lib_1.encode)(siblingExample));
        t.is(result.a, result.b);
    });
}
{
    const circular = { self: undefined };
    circular.self = circular;
    (0, ava_1.default)("self ref - structural", complexReferences, circular, (0, tools_1.preszr)((0, tools_1.items)({ self: "1" })));
    (0, ava_1.default)("self ref - identity", t => {
        const result = (0, _lib_1.decode)((0, _lib_1.encode)(circular));
        t.is(result.self, result);
    });
}
{
    const circular = [];
    circular.push(circular);
    (0, ava_1.default)("array self ref - structural", complexReferences, circular, (0, tools_1.preszr)((0, tools_1.items)(["1"])));
    (0, ava_1.default)("array self ref - identity", t => {
        const r = (0, _lib_1.decode)((0, _lib_1.encode)(circular));
        t.is(r[0], r);
    });
}
{
    const mutuallyCircular1 = { other: undefined };
    const mutuallyCircular2 = { other: undefined };
    mutuallyCircular1.other = mutuallyCircular2;
    mutuallyCircular2.other = mutuallyCircular1;
    (0, ava_1.default)("mutually circular refs - structure", complexReferences, mutuallyCircular1, (0, tools_1.preszr)((0, tools_1.items)({ other: "2" }, { other: "1" })));
    (0, ava_1.default)("mutually circular refs - identity", t => {
        const first = (0, _lib_1.decode)((0, _lib_1.encode)(mutuallyCircular1));
        const other = first.other;
        t.is(other.other, first);
    });
}
//# sourceMappingURL=complex-references.js.map