"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = __importDefault(require("ava"));
const tools_1 = require("../tools");
const default_1 = require("@lib/default");
const fixed_1 = require("@lib/encodings/fixed");
const mapEncoding = (0, tools_1.testBuilder)(default_1.defaultPreszr)
    .title(({ title }) => `Map - ${title}`)
    .getSimple();
(0, ava_1.default)("empty", mapEncoding, new Map(), (0, tools_1.preszr)((0, tools_1.encoded)([], fixed_1.Fixed.Map)));
(0, ava_1.default)("one pair", mapEncoding, new Map([[1, 2]]), (0, tools_1.preszr)((0, tools_1.encoded)([[1, 2]], fixed_1.Fixed.Map)));
(0, ava_1.default)("object key", mapEncoding, new Map([[{}, 1]]), (0, tools_1.preszr)((0, tools_1.encoded)([["2", 1]], fixed_1.Fixed.Map), (0, tools_1.items)({})));
(0, ava_1.default)("ref key-value", mapEncoding, new Map([[{}, {}]]), (0, tools_1.preszr)((0, tools_1.encoded)([["2", "3"]], fixed_1.Fixed.Map), (0, tools_1.items)({}, {})));
(0, ava_1.default)("two items", mapEncoding, new Map([
    [1, 2],
    [2, 3]
]), (0, tools_1.preszr)((0, tools_1.encoded)([
    [1, 2],
    [2, 3]
], fixed_1.Fixed.Map)));
(0, ava_1.default)("nested map", mapEncoding, new Map([[new Map(), 5]]), (0, tools_1.preszr)((0, tools_1.encoded)([["2", 5]], fixed_1.Fixed.Map), (0, tools_1.encoded)([], fixed_1.Fixed.Map)));
(0, ava_1.default)("string key", mapEncoding, new Map([["a", 2]]), (0, tools_1.preszr)((0, tools_1.encoded)([["2", 2]], fixed_1.Fixed.Map), (0, tools_1.items)("a")));
// Test same ref, unsupported
//# sourceMappingURL=map.js.map