"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = __importDefault(require("ava"));
const utils_1 = require("../utils");
const default_1 = require("@lib/default");
const tools_1 = require("../tools");
const primtiveTests = (0, tools_1.testBuilder)(default_1.defaultPreszr)
    .title(({ original, title }) => title ?? `Primitive - ${(0, utils_1.stringify)(original)}`)
    .getSimple();
ava_1.default.failing("check test fails on mismatch", primtiveTests, 1, 2);
(0, ava_1.default)(primtiveTests, true, true);
(0, ava_1.default)(primtiveTests, null, null);
(0, ava_1.default)(primtiveTests, Infinity, "Infinity");
(0, ava_1.default)(primtiveTests, -Infinity, "-Infinity");
(0, ava_1.default)(primtiveTests, -0, "-0");
(0, ava_1.default)(primtiveTests, NaN, "NaN");
(0, ava_1.default)(primtiveTests, undefined, "-");
(0, ava_1.default)("bigint", primtiveTests, 4n, "B4");
//# sourceMappingURL=primitives.js.map