"use strict";
/* eslint-disable no-new-wrappers */
/* tslint:disable:no-construct */
// noinspection JSPrimitiveTypeWrapperUsage
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = __importDefault(require("ava"));
const tools_1 = require("../tools");
const default_1 = require("@lib/default");
const fixed_1 = require("@lib/encodings/fixed");
const scalarEncodings = (0, tools_1.testBuilder)(default_1.defaultPreszr).getSimple();
(0, ava_1.default)("deepEqual works on object primitives", t => {
    t.deepEqual(new Number(5), new Number(5));
    t.notDeepEqual(5, new Number(5));
    t.deepEqual(new Boolean(true), new Boolean(true));
    t.notDeepEqual(new Boolean(true), true);
    t.deepEqual(new String(""), new String(""));
    t.notDeepEqual(new String(""), "");
});
(0, ava_1.default)("deepEqual works on dates", t => {
    const now = Date.now();
    t.deepEqual(new Date(now), new Date(now));
    t.notDeepEqual(new Date(now), new Date(now - 1));
});
(0, ava_1.default)("deepEqual works on regex", t => {
    const regex = /abc/;
    t.deepEqual(regex, /abc/);
    t.notDeepEqual(regex, /abcd/);
    t.notDeepEqual(regex, /abc/i);
    t.notDeepEqual(regex, "abc");
});
(0, ava_1.default)("Number wrapper", scalarEncodings, new Number(5), (0, tools_1.preszr)((0, tools_1.encoded)(5, fixed_1.Fixed.FundNumber)));
(0, ava_1.default)("Boolean wrapper", scalarEncodings, new Boolean(5), (0, tools_1.preszr)((0, tools_1.encoded)(true, fixed_1.Fixed.FundBool)));
(0, ava_1.default)("String wrapper", scalarEncodings, new String("x"), (0, tools_1.preszr)((0, tools_1.encoded)("x", fixed_1.Fixed.FundString)));
const date = new Date();
(0, ava_1.default)("Date", scalarEncodings, date, (0, tools_1.preszr)((0, tools_1.encoded)(date.getTime(), fixed_1.Fixed.Date)));
(0, ava_1.default)("RegExp no flags", scalarEncodings, /abc/, (0, tools_1.preszr)((0, tools_1.encoded)("abc", fixed_1.Fixed.RegExp)));
(0, ava_1.default)("RegExp with flags", scalarEncodings, /abc/gi, (0, tools_1.preszr)((0, tools_1.encoded)(["abc", "gi"], fixed_1.Fixed.RegExp)));
//# sourceMappingURL=scalar-objects.js.map