"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = __importDefault(require("ava"));
const utils_1 = require("../utils");
const tools_1 = require("../tools");
const default_1 = require("@lib/default");
const simpleObjectEncoding = (0, tools_1.testBuilder)(default_1.defaultPreszr)
    .title(({ title, original }) => title ?? `single value - ${(0, utils_1.stringify)(original.value)}`)
    .getSimple();
(0, ava_1.default)(simpleObjectEncoding, { value: 1 }, (0, tools_1.preszr)((0, tools_1.items)({ value: 1 })));
(0, ava_1.default)(simpleObjectEncoding, { value: true }, (0, tools_1.preszr)((0, tools_1.items)({ value: true })));
(0, ava_1.default)(simpleObjectEncoding, { value: null }, (0, tools_1.preszr)((0, tools_1.items)({ value: null })));
(0, ava_1.default)(simpleObjectEncoding, { value: Infinity }, (0, tools_1.preszr)((0, tools_1.items)({ value: "Infinity" })));
(0, ava_1.default)(simpleObjectEncoding, { value: -Infinity }, (0, tools_1.preszr)((0, tools_1.items)({ value: "-Infinity" })));
(0, ava_1.default)(simpleObjectEncoding, { value: -0 }, (0, tools_1.preszr)((0, tools_1.items)({ value: "-0" })));
(0, ava_1.default)(simpleObjectEncoding, { value: NaN }, (0, tools_1.preszr)((0, tools_1.items)({ value: "NaN" })));
(0, ava_1.default)(simpleObjectEncoding, { value: undefined }, (0, tools_1.preszr)((0, tools_1.items)({ value: "-" })));
(0, ava_1.default)(simpleObjectEncoding, { value: 4n }, (0, tools_1.preszr)((0, tools_1.items)({ value: "B4" })));
(0, ava_1.default)(simpleObjectEncoding, { value: "string" }, (0, tools_1.preszr)((0, tools_1.items)({ value: "2" }, "string")));
(0, ava_1.default)("strings are interned", simpleObjectEncoding, { a: "string", b: "string" }, (0, tools_1.preszr)((0, tools_1.items)({
    a: "2",
    b: "2"
}, "string")));
(0, ava_1.default)(simpleObjectEncoding, { value: [] }, (0, tools_1.preszr)((0, tools_1.items)({ value: "2" }, [])));
(0, ava_1.default)("string", simpleObjectEncoding, "abc", (0, tools_1.preszr)((0, tools_1.items)("abc")));
(0, ava_1.default)("object ref", simpleObjectEncoding, { a: {} }, (0, tools_1.preszr)((0, tools_1.items)({ a: "2" }, {})));
{
    const objWithNonEnumerable = {};
    Object.defineProperty(objWithNonEnumerable, "nonEnumerable", {
        enumerable: false
    });
    (0, ava_1.default)("test object is set up right", t => {
        t.false(Object.getOwnPropertyDescriptor(objWithNonEnumerable, "nonEnumerable").enumerable);
    });
    (0, ava_1.default)("skips non-enumerable", t => {
        const realEncoded = default_1.defaultPreszr.encode(objWithNonEnumerable);
        t.deepEqual(realEncoded, (0, tools_1.preszr)((0, tools_1.items)({})));
    });
}
//# sourceMappingURL=simple-objects.js.map