"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ava_1 = __importDefault(require("ava"));
const _lib_1 = require("@lib");
(0, ava_1.default)("simple object", t => {
    const obj2 = {};
    const obj = {
        boolean: true,
        number: 1,
        nonJsonNumber: Infinity,
        string: "hello",
        alsoString: "hello",
        undefined,
        null: null,
        bigint: BigInt("1000000000000000000000000"),
        binary: new Uint8Array([1, 2, 3, 4]),
        error: new Error(),
        nullProtoObject: Object.create(null, {
            value: {
                value: 5,
                enumerable: true
            }
        }),
        map: new Map([[1, 1]]),
        set: new Set([5]),
        array: [1],
        date: new Date(),
        regexp: /abc/gi,
        ref1: obj2,
        ref2: obj2
    };
    const decoded = (0, _lib_1.decode)(JSON.parse(JSON.stringify((0, _lib_1.encode)(obj))));
    t.deepEqual(decoded, obj);
    t.is(decoded.ref1, decoded.ref2);
});
(0, ava_1.default)("circular references", t => {
    const obj = {
        circular: null
    };
    obj.circular = obj;
    const decoded = (0, _lib_1.decode)(JSON.parse(JSON.stringify((0, _lib_1.encode)(obj))));
    t.is(decoded, decoded.circular);
});
(0, ava_1.default)("custom class", t => {
    class MyCustomClass {
        myMethod() {
            return 10;
        }
    }
    const preszr = (0, _lib_1.Preszr)({
        encodes: [MyCustomClass]
    });
    const instance = new MyCustomClass();
    const decoded = preszr.decode(JSON.parse(JSON.stringify(preszr.encode(instance))));
    t.deepEqual(decoded, instance);
    t.is(instance.myMethod(), 10);
});
//# sourceMappingURL=standard.js.map