"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable symbol-description */
const ava_1 = __importDefault(require("ava"));
const utils_1 = require("../../lib/utils");
const _lib_1 = require("@lib");
const tools_1 = require("../tools");
const fixed_1 = require("@lib/encodings/fixed");
function getSymbolKey(s) {
    return `${s.description}.S`;
}
const symb1 = Symbol("symbol1");
const symb2 = Symbol("symbol2");
(0, ava_1.default)("unrecognized symbol name generator", t => {
    t.is((0, utils_1.getSymbolName)((0, utils_1.getUnrecognizedSymbol)("x")), "preszr unknown: x");
});
// First let's check recognized symbols only...
{
    const knows1 = (0, _lib_1.Preszr)([symb1]);
    const stdTest = (0, tools_1.testBuilder)(knows1).get();
    const symbolEncName = getSymbolKey(symb1);
    (0, ava_1.default)("symbol input", stdTest, {
        original: symb1,
        encoded: (0, tools_1.preszr)((0, tools_1.encoded)(0, symbolEncName))
    });
    (0, ava_1.default)("symbol value", stdTest, {
        original: { x: symb1 },
        encoded: (0, tools_1.preszr)((0, tools_1.items)({ x: "2" }), (0, tools_1.encoded)(0, symbolEncName))
    });
    (0, ava_1.default)("symbol key", stdTest, {
        original: { [symb1]: 10 },
        encoded: (0, tools_1.preszr)((0, tools_1.encoded)([{ "2": 10 }, {}], fixed_1.Fixed.Object), (0, tools_1.encoded)(0, symbolEncName))
    });
}
{
    const knows2 = (0, _lib_1.Preszr)([symb1, symb2]);
    const stdTest = (0, tools_1.testBuilder)(knows2).get();
    (0, ava_1.default)("two symbol keys", stdTest, {
        original: {
            [symb1]: 1,
            [symb2]: 2
        },
        encoded: (0, tools_1.preszr)((0, tools_1.encoded)([{ "2": 1, "3": 2 }, {}], fixed_1.Fixed.Object), (0, tools_1.encoded)(0, getSymbolKey(symb1)), (0, tools_1.encoded)(0, getSymbolKey(symb2)))
    });
    (0, ava_1.default)("two symbol keys, values", stdTest, {
        original: {
            [symb1]: symb2,
            [symb2]: symb1
        },
        encoded: (0, tools_1.preszr)((0, tools_1.encoded)([{ "2": "3", "3": "2" }, {}], fixed_1.Fixed.Object), (0, tools_1.encoded)(0, getSymbolKey(symb1)), (0, tools_1.encoded)(0, getSymbolKey(symb2)))
    });
    (0, ava_1.default)("symbol keys + regular keys", stdTest, {
        original: {
            [symb1]: 2,
            a: 3
        },
        encoded: (0, tools_1.preszr)((0, tools_1.encoded)([{ 2: 2 }, { a: 3 }], fixed_1.Fixed.Object), (0, tools_1.encoded)(0, getSymbolKey(symb1)))
    });
}
//# sourceMappingURL=symbols.js.map