"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TestBuilder = void 0;
const ava_1 = __importDefault(require("ava"));
const _lib_1 = require("@lib");
class TestBuilder {
    with(partial) {
        const builder = Object.create(Object.getPrototypeOf(this));
        Object.assign(builder, this, partial);
        return builder;
    }
    instance(instance) {
        return this.with({
            _instance: instance
        });
    }
    title(f) {
        return this.with({
            _title: typeof f === "string" ? () => f : f
        });
    }
    get() {
        const self = this;
        return ava_1.default.macro({
            exec(t, args) {
                return self._test(t, {
                    ...args,
                    instance: self._instance ?? (0, _lib_1.Preszr)()
                });
            },
            title(title, args) {
                return (self._title?.({
                    ...args,
                    title
                }) ?? title);
            }
        });
    }
}
exports.TestBuilder = TestBuilder;
//# sourceMappingURL=base-test-builder.js.map