"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Inspector = void 0;
const fixed_1 = require("@lib/encodings/fixed");
class Inspector {
    constructor(_inner) {
        this._inner = _inner;
        this._inner = [["1", [], {}, {}]];
    }
    get(i) {
        if (arguments.length === 0) {
            return this._inner;
        }
        return this._inner[i + 1];
    }
    get length() {
        return this._inner.length - 1;
    }
    setEncoding(newIndex, encodingKey) {
        if (typeof encodingKey === "number") {
            this.spec[newIndex] = encodingKey;
            return this;
        }
        const ix = this.keys.indexOf(encodingKey);
        if (ix < 0) {
            this.keys.push(encodingKey);
            this.spec[newIndex] = fixed_1.Fixed.End + this.keys.length - 1;
        }
        else {
            this.spec[newIndex] = ix;
        }
    }
    push(v, encoding) {
        const newIndex = this.length + 1;
        this._inner.push(v);
        if (encoding != null) {
            this.setEncoding(newIndex, encoding);
        }
    }
    set(i, x) {
        this._inner[i + 1] = x;
        return this;
    }
    get version() {
        return this._inner[0][0];
    }
    set version(x) {
        this._inner[0][0] = x;
    }
    get keys() {
        return this._inner[0][1];
    }
    set keys(keys) {
        this._inner[0][1] = keys;
    }
    get spec() {
        return this._inner[0][2];
    }
    set spec(x) {
        this._inner[0][2] = x;
    }
    get metadata() {
        return this._inner[0][3];
    }
    set metadata(x) {
        this._inner[0][3] = x;
    }
}
exports.Inspector = Inspector;
/*
    Message(encoded("abc", axvx), encoded("asdg", axvx))
 */
//# sourceMappingURL=inspector.js.map