"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.using = exports.TestBuilder = void 0;
const ava_1 = __importDefault(require("ava"));
class TestBuilder {
    constructor(_instance) {
        this._instance = _instance;
    }
    title(f) {
        this._title = f;
        return this;
    }
    getTitleGetter() {
        const { _title } = this;
        return (title, decoded, encoded) => _title?.({
            encoded,
            decoded,
            title
        }) ?? title;
    }
    encodeDecodeDeepEqual() {
        const { _instance } = this;
        return ava_1.default.macro({
            exec(t, decoded, encoded) {
                const toEncoded = _instance.encode(decoded);
                t.deepEqual(toEncoded, encoded, "ENCODED VALUE MISMATCH");
                const toDecoded = _instance.decode(encoded);
                t.deepEqual(toDecoded, decoded, "DECODED VALUE MISMATCH");
            },
            title: this.getTitleGetter()
        });
    }
}
exports.TestBuilder = TestBuilder;
function using(instance) {
    return new TestBuilder(instance);
}
exports.using = using;
//# sourceMappingURL=macros.js.map