import { PreszrFormat } from "@lib/data";
import { ExecutionContext, Macro } from "ava";
import { InitContext, EncodeContext } from "@lib";
export declare const stringify: (value: any) => string;
export declare function getImplicitClassEncodingKey(cls: string): string;
export declare function createSparseArray<T>(arrayLikeObj: Record<any, T>): T[];
export declare function createArrayBuffer(...bytes: number[]): ArrayBufferLike;
export declare function createSharedArrayBuffer(...bytes: number[]): SharedArrayBuffer;
export declare function embedPreszrVersion(encoded: any): any;
export declare function getEncodingComponent(encodingSpec: any): any[];
export declare function simplifyEncoding(encoding: PreszrFormat): PreszrFormat;
export declare function createPreszrRep([encodingSpec, meta]: [any, any], ...arr: any[]): PreszrFormat;
export declare function preszrDefaultHeader(...arr: any[]): PreszrFormat;
export declare function createWithTitle(macro: any, argsFunc: any, titleFunc: any): {
    (t: any, ...args: any[]): any;
    title: any;
};
export declare const testEncodeMacro: any;
export declare const testDecodeMacro: any;
export declare const testEncodeMacroBindPreszr: (preszr: any) => (a: any, b: any, c: any) => any;
export declare const testDecodeMacroBindPreszr: (preszr: any) => (a: any, b: any, c: any) => any;
export declare const combAttachHeader: (titleFunc: any) => [Macro<any, unknown>, Macro<any, unknown>];
export declare function getDummyCtx(): EncodeContext & InitContext;
export interface EncodeDecodeMacros {
    decode(t: ExecutionContext, decoded: any, encoded: any): any;
    encode(t: ExecutionContext, decoded: any, encoded: any): any;
}
export declare const encodeDecodeMacro: (args: EncodeDecodeMacros) => [any, any];
export declare function toBase64(buf: ArrayBuffer): string;
